#include <sys/atom.h>

extern void NutMicroDelay(u_short us)
{
#ifdef __GNUC__
    //15 clock cycles per microsecond for 14.745600 MHz Clock (cca 1,7% error)
    asm volatile (
      "cpi %A0,0\n"
      "L_ud_loop%=:\n"
      "breq L_ud_testhigh%=\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "dec %A0\n"
      "rjmp L_ud_loop%=\n"

      "L_ud_testhigh%=:\n"
      "cpi %B0,0\n"
      "breq L_ud_end%=\n"
      "dec %B0\n"
      "dec %A0\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "nop\n"
      "rjmp L_ud_loop%=\n"

      "L_ud_end%=:\n"
      : : "r" (us)
    );
#else
    u_long delay_cnt = 3*us; //not tested, surely less acurate than GNUC code
    while (delay_cnt--);
#endif
}
